{
    "header": {
        "version": 1,
        "type": "record",
        "approw-key": "SRP_EDITOR_HISTORY"
    },
    "body": {
        "record1": {
            "<1>": {
                "<1,1>": "3.4.5",
                "<1,2>": "Fixed syntax coloring bug when using multibyte UTF-16 characters in strings and comments"
            },
            "<2>": {
                "<2,1>": "3.4.4",
                "<2,2>": "Updated Open Record dialog to always default to previous table and record",
                "<2,3>": "Fixed false â€œStored Procedure not foundâ€ errors",
                "<2,4>": "Fixed Open Record dialog's Refresh button setting text to \"1\" in OI 10",
                "<2,5>": "Fixed CLIENTSIZE returning wrong value in some RDP environments",
                "<2,6>": "Fixed anchoring of button on Add to Repository form in OI 10",
                "<2,7>": "Fixed VNAV when using F9 to save records"
            },
            "<3>": {
                "<3,1>": "3.4.3",
                "<3,2>": "Added Hook and Unhook TCL commands",
                "<3,3>": "Improved VNAV filtering",
                "<3,4>": "Fixed Open Record dialog's Refresh button in OI 10",
                "<3,5>": "Fixed incorrect VNAVs in OI 10"
            },
            "<4>": {
                "<4,1>": "3.4.2",
                "<4,2>": "Added New button to RDK Window",
                "<4,3>": "Updated SRP Editor to save favorites and opened file lists every time it changes instead of when closing"
            },
            "<5>": {
                "<5,1>": "3.4.1",
                "<5,2>": "Added Expand All and Collapse All to Edit menu",
                "<5,3>": "Updated Open Record dialog to better handle Quickdex indexes",
                "<5,4>": "Updated deletion of procedures and inserts to also update git repo",
                "<5,5>": "Updated auto-commenter to no longer insert unnecessary spaces",
                "<5,6>": "Updated tooltips to be DPI aware in OI 10",
                "<5,7>": "Updated Favorites and Test panels to reset to defaults if sizes become inordinately large",
                "<5,8>": "Fixed Find Previous not working in OI 9",
                "<5,9>": "Fixed false VNAVs for variables inside function calls",
                "<5,10>": "Fixed Replace All inserting replacements at beginning of next line",
                "<5,11>": "Fixed New Item screen DPI issues in OI 10"
            },
            "<6>": {
                "<6,1>": "3.4",
                "<6,2>": "Added Calendar control to SRP_ActiveX_Info",
                "<6,3>": "Added DPI awareness for OI 10",
                "<6,4>": "Updated OI 10 version to initialize OIPI before printing, not during startup",
                "<6,5>": "Updated SRP_ActiveX_Info to be more tolerant of missing registrations",
                "<6,6>": "Updated OI 10 version to support changes to OI 10.2",
                "<6,7>": "Fixed bug in OI 10 where event dropdowns for OI controls would be empty"
            },
            "<7>": {
                "<7,1>": "3.3.8",
                "<7,2>": "Added Shift+F2 shortcut to jump to previous marker",
                "<7,3>": "Updated Add to RDK dialog to work correctly with OI 10 RDK format",
                "<7,4>": "Fixed bug where opening a record from a CODE table that wasnâ€™t code would hang"
            },
            "<8>": {
                "<8,1>": "3.3.7",
                "<8,2>": "Fixed splitter bar settings in OI 10"
            },
            "<9>": {
                "<9,1>": "3.3.6",
                "<9,2>": "Updated Help menu command to open OI Help in OI 10",
                "<9,3>": "Fixed bug in OI 10 where Ctrl+F and Ctrl+H wouldnâ€™t work in some circumstances"
            },
            "<10>": {
                "<10,1>": "3.3.5",
                "<10,2>": "Fixed bug where List command would not format some columns",
                "<10,3>": "Fixed bug where Find window would clear out Label List combo box during search"
            },
            "<11>": {
                "<11,1>": "3.3.4",
                "<11,2>": "Fixed bug where Find would not highlight a word if it was the last word in the document",
                "<11,3>": "Fixed bug where undoing a record expansion would not update the margin to match the change"
            },
            "<12>": {
                "<12,1>": "3.3.3",
                "<12,2>": "Updated Format tool to ignore code between #pre and #endpre directives (requires SRP Utilities 2.2)",
                "<12,3>": "Fixed bug where selecting large numbers would break to debugger"
            },
            "<13>": {
                "<13,1>": "3.3.2",
                "<13,2>": "Added directives to autocomplete dropdown, e.g., #ifdef, #region, etc.",
                "<13,3>": "Fixed bug where autojustify would break while Find/Replace was active"
            },
            "<14>": {
                "<14,1>": "3.3.1",
                "<14,2>": "Removed autofill from combo boxes in Find/Replace windows"
            },
            "<15>": {
                "<15,1>": "3.3",
                "<15,2>": "Added check for existing stored procedures during compile",
                "<15,3>": "Added Copy Special... menu item",
                "<15,4>": "Updated Copy logic to only copy text in color. For line numbers, use the new Copy Special... menu item",
                "<15,5>": "Updated Find and Replace dialogs to appear in top right corner of editor",
                "<15,6>": "Updated Find dialog to stay open",
                "<15,7>": "Updated Find and Replace to highlight all instances of search text while dialog is open",
                "<15,8>": "Updated Find and Replace to show X of Y when moving to Next and Previous search",
                "<15,9>": "Updated Replace dialog to support F4",
                "<15,10>": "Updated license handling",
                "<15,11>": "Updated VNAV handling to exlude variables after DIM/DIMENSION statement",
                "<15,12>": "Fixed bug where adding new lines after a THEN keyword would insert an END keyword below even if there is already an END or END ELSE",
                "<15,13>": "Fixed bug where new Events or Services (Extended BASIC+) wouldn't get code folded",
                "<15,14>": "Fixed bug where Unit Testing panel would not resize when hiding/showing Command Line",
                "<15,15>": "Fixed bug where Update_Index tooltip didn't show new parameter: bSuppressMsg",
                "<15,16>": "Fixed bug where Ctrl+U would not work if a partial word was selected",
                "<15,17>": "Fixed bug where Ctrl+J would not handle empty elements safely"
            },
            "<16>": {
                "<16,1>": "3.2.3",
                "<16,2>": "Fixed references to SRPControls.ocx that should have reference SRPEditor.ocx",
                "<16,3>": "Fixed options dialog to update unit test panel when theme changes",
                "<16,4>": "Fixed bug where changing theme would sometimes leave behind artifacts from other themes",
                "<16,5>": "Fixed bug where auto indent would sometimes insert an extra tab"
            },
            "<17>": {
                "<17,1>": "3.2.2",
                "<17,2>": "Updated folding algorithm to better handle blanks lines before and after a fold"
            },
            "<18>": {
                "<18,1>": "3.2.1",
                "<18,2>": "Fixed critical bug where saving records with @RMs could corrupt record data by reposition @RMs in wrong location",
                "<18,3>": "Fixed bug where region name wouldn't update correctly in Label List or sometimes disappear",
                "<18,4>": "Fixed bug where deleting DEBUG would not delete the margin marker",
                "<18,5>": "Fixed bug where VIEWER window would cause tabs to get out of sync or mislabelled"
            },
            "<19>": {
                "<19,1>": "3.2",
                "<19,2>": "Added code folding",
                "<19,3>": "Added splash screen"
            },
            "<20>": {
                "<20,1>": "3.1.4",
                "<20,2>": "Fixed bug where new records wouldn't show <1> in the margin and would error out upon pressing ENTER"
            },
            "<21>": {
                "<21,1>": "3.1.3",
                "<21,2>": "Updated IConv/OConv context menus to better recognize legitimate conversions",
                "<21,3>": "Improved record loading/editing speeds, especially for large records",
                "<21,4>": "Fixed bug where Favorited records would sometimes reopen in Forced Readonly mode",
                "<21,5>": "Fixed bug where Open Record dialog would not highlight correct field when opened",
                "<21,6>": "Fixed bug where License screens would appear when they shouldn't"
            },
            "<22>": {
                "<22,1>": "3.1.2",
                "<22,2>": "Updated SRP Editor to auto-insert SRP_PreCompiler when unpacking syntax is used."
            },
            "<23>": {
                "<23,1>": "3.1.1",
                "<23,2>": "Added opption to disable auto-insertion of the SRP_PreCompiler"
            },
            "<24>": {
                "<24,1>": "3.1",
                "<24,2>": "Added OI 10 support",
                "<24,3>": "Added Joker and Visual Studio Dark themes",
                "<24,4>": "Added button to Options dialog for adding SRP Editor to the IDE's Tool Menu",
                "<24,5>": "Added Auto Justify Assignments feature (see Options)",
                "<24,6>": "Updated to better interact with APPROW entities when SRP Git is enabled",
                "<24,7>": "Updated Open Procedure dialog to ignore AREV32's \"SOURCE:\" pointers",
                "<24,8>": "Updated Main UI settings to be saved per app, instead of globally to all apps",
                "<24,9>": "Updated Open Record dialog to default to active record's table and key instead of the last table and key",
                "<24,10>": "Fixed bug where dialog boxes would show on wrong monitor",
                "<24,11>": "Fixed bug where licensing boxes would crash OI",
                "<24,12>": "Fixed bug where saving stored procedures would append \\00\\",
                "<24,13>": "Fixed bug where creating new items would cause all MDI windows to un-maximize",
                "<24,14>": "Fixed bug where Table Search progress bar was not accurate",
                "<24,15>": "Fixed bug where Table Search would search when pressing ENTER even though the Results window had focus"
            },
            "<25>": {
                "<25,1>": "3.0.3",
                "<25,2>": "Updated SRP Editor to recognize SRP Git when writing files to ensure they get pushed to the Git repo",
                "<25,3>": "Updated Git menu",
                "<25,4>": "Updated SRP Table Search",
                "<25,5>": "Updated Code Format tool to recognize Enhanced BASIC+",
                "<25,6>": "Updated \"Tabs as Spaces\" options to be enabled by default",
                "<25,7>": "Fixed bug where Bookmarks from one document would load in another",
                "<25,8>": "Fixed bug where items wouldn't save correctly during shutdown",
                "<25,9>": "Fixed bug where new item couldn't be dragged in Favorites pane after being Saved",
                "<25,10>": "Fixed bug where EDIT command would not open empty records",
                "<25,11>": "Fixed bug where doing a Save and Compile (F9) of a new stored procedures wouldn't compile"
            },
            "<26>": {
                "<26,1>": "3.0.2",
                "<26,2>": "Added Git menu, which displays different options if SRP GIT Utility is installed.",
                "<26,3>": "Added special icon for records forced into readonly mode.",
                "<26,4>": "Added single-key accelerators to the New item window.",
                "<26,5>": "Updated Record Open window to be much, much faster.",
                "<26,6>": "Updated favorites to remember when records were forced to open readonly.",
                "<26,7>": "Updated Event modules to auto-append .MENU() when selecting a MENU event from the dropdown",
                "<26,8>": "Updated several autocomplete dropdowns to appear immediately after pressing space instead of waiting for a leading character, e.g., after gosub, goto, and $insert",
                "<26,9>": "Fixed occasional bug where selecting a control in an Event would append empty parameters instead of letting the user select an event"
            },
            "<27>": {
                "<27,1>": "3.0.1",
                "<27,2>": "Added keyword highlighting for API and GoToAPI (requires SRPUtil.ocx 4.0.8 or later)",
                "<27,3>": "Added support within SRP_PreCompiler for API and GoToAPI keywords",
                "<27,4>": "Updated SRP Editor to automatically save and restore bookmarks between sessions within stored procedures (requires SRPUtil.ocx 4.0.8 or later)",
                "<27,5>": "Updated SRP Editor to save and restore location and selection information between sessions within stored procedures and inserts (requires SRPUtil.ocx 4.0.8 or later)",
                "<27,6>": "Extended syntax highlighting of brace matching to also include { }, < >, [ ] (requires SRPUtil.ocx 4.0.8 or later)",
                "<27,7>": "Fixed \"Refresh\" typo in Unit Test panel context menu",
                "<27,8>": "Fixed bug preventing user from showing/hiding the Unit Test panel unless the Favorites panel was visible"
            },
            "<28>": {
                "<28,1>": "3.0",
                "<28,2>": "Added Unit Testing",
                "<28,3>": "Added New Item window that is now bound to Ctrl+N (File, New)",
                "<28,4>": "Added code templates",
                "<28,5>": "Updated Run window to recognize metadata",
                "<28,6>": "Updated SRP PreCompiler to place common variables at @pragma line instead of at the beginning of the first Etended BASIC+ line. #pragma should be as close to the top of the code as possible as a result.",
                "<28,7>": "Updated TCL to no longer auto complete, though the dropdown will still appear with a filtered history of previously used commands",
                "<28,8>": "Updated Table Search utility to sort tables",
                "<28,9>": "Fixed bug where SRP Editor would crash on OI 9.1 and earlier when closing document from Favorites",
                "<28,10>": "Fixed bug where \"end\" keyword would be auto-inserted if a one-line if statement ended with a debug",
                "<28,11>": "Fixed bug where visual artifact would appear when resizing Open Record dialog",
                "<28,12>": "Fixed bug where wrong parameter types would appear for DLL stubs"
            },
            "<29>": {
                "<29,1>": "2.9.1",
                "<29,2>": "Added support for Setting keyword in For Each loop to allow developers to include a counter",
                "<29,3>": "Added ability to close documents directly from the tab strip",
                "<29,4>": "Added ability to close documents directly from the Favorites pane",
                "<29,5>": "Added smart insert feature to automatically insert block closers (e.g., End after If or Repeat after Loop)",
                "<29,6>": "Added ability to customize keyword case in autocomplete and smart indents (See Customize Tab)",
                "<29,7>": "Added right-click context menus to Favorites pane for more intuitive interaction",
                "<29,8>": "Updated SRP_PreCompiler to use older op-codes when compiled in OI 9.1.x or earlier",
                "<29,9>": "Updated SRP_PreCompiler to support both \"or\" or \"else\" keyword in Enhanced BASIC+ Return statement, e.g., \"Return Ans else 1\"",
                "<29,10>": "Updated SRP_PreCompiler to ignore writing meta data when called from BLINT",
                "<29,11>": "Updated width of Label combo box",
                "<29,12>": "Updated auto complete to complete on Tab as well as Enter",
                "<29,13>": "Updated Favorites panel with context menu for more intuitive control over favorites",
                "<29,14>": "Updated SRP Editor to close a faster and more reliably when there are unsaved documents",
                "<29,15>": "Fixed bug in SRP_PreCompiler where Enhanced BASIC+ keywords within comment blocks were not being ignored",
                "<29,16>": "Fixed bug in SRP_PreCompiler where GoToEvent would sometimes not find the correct event handler",
                "<29,17>": "Fixed bug in SRP_PreCompiler where While/Until clauses sometimes wouldn't compile",
                "<29,18>": "Fixed bug in SRP_PreCompiler where For Each would miss last element if it was a single letter",
                "<29,19>": "Fixed bug in SRP_PreCompiler where Service with no parameters would offset the debugger by one line",
                "<29,20>": "Fixed bug in SRP_PrcCompiler where wrong service metadata would be created if procedure had inherited version"
            },
            "<30>": {
                "<30,1>": "2.9",
                "<30,2>": "Added SRP_PreCompiler to support Enhanced BASIC+",
                "<30,3>": "Added syntax highlighting support for Enhanced BASIC+ (requires SRPUtil.ocx 4.0.3 or later)",
                "<30,4>": "Added automatic insertion of SRP_PreCompiler during compile when Enhanced BASIC+ is detected (requires SRPUtil.ocx 4.0.3 or later)",
                "<30,5>": "Added ability to right click to Insert SRP_PreCompiler (requires SRPUtil.ocx 4.0.3 or later)",
                "<30,6>": "Added syntax highlighting for directives (e.g., #pragma). Updated built-in themes to support it also.",
                "<30,7>": "Updated MENU.HELP to check for ProgRef.chm before trying to run it",
                "<30,8>": "Updated Open Record dialog's autofill to improve speed and reduce dropped characters (requires SRPUtil.ocx 4.0.3 or later)",
                "<30,9>": "Updated Label dropdown to match typed input anywhere, so typing CREATE will find CREATE, WINDOW.CREATE, MY_CREATE, etc.",
                "<30,10>": "Updated Goto Source function (F12) to be more forgiving about finding the correct label",
                "<30,11>": "Fixed Options dialog Theme button using SRPControls.ocx instead of SRPUtil.ocx",
                "<30,12>": "Fixed bug where printing records started on field <2> instead of field <1>",
                "<30,13>": "Fixed bug where highlighting whole label at end of line didn't jump to that label when performing Goto Source function (F12)",
                "<30,14>": "Fixed bug where VNAV detection was sometimes inaacurate (requires SRPUtil.ocx 4.0.3 or later)",
                "<30,15>": "Fixed bug where VNAV detection would be applied to cached code when compiling inherited stored procedures",
                "<30,16>": "Fixed bug where some document types would not be marked as modified (needing to be saved) when doing a find & replace"
            },
            "<31>": {
                "<31,1>": "2.8",
                "<31,2>": "Added syntax highlighting themes",
                "<31,3>": "Added support for themes, so it will be easier to switch between themes on the fly",
                "<31,4>": "Added ability to export/import all options to/from a file",
                "<31,5>": "Added logic to reset Status window on startup if it's too large to fit",
                "<31,6>": "Updated Styles to be cascading, so everything falls back to Default style when not set",
                "<31,7>": "Updated all icons to more modern ones",
                "<31,8>": "Updated Compile function (F9) to automatically calls DECLARE_FCNS for \"SYSPROC*DLL_\" records",
                "<31,9>": "Updated Auto text settings to now save to %APPDATA%\\Roaming as text files instead of using the registry to allow for more characters",
                "<31,10>": "Updated F12 to jump to label if cursor is on a label identifier",
                "<31,11>": "Updated \"This Application Only\" check box in Open dialog to put focus back into the main edit field after being clicked",
                "<31,12>": "Fixed bug where labels followed by \"*\" or \"//\" were not recognized",
                "<31,13>": "Fixed bug where some compiler errors were not displaying correctly in the status pane"
            },
            "<32>": {
                "<32,1>": "2.7.1",
                "<32,2>": "Fixed false-positive error message appearing when running SRP Editor from 9.x IDE",
                "<32,3>": "Fixed bug where tree items showing tooltips needed to be clicked twice",
                "<32,4>": "Fixed bug where clicking on Records or DOS files in the Favorites panel didn't work"
            },
            "<33>": {
                "<33,1>": "2.7",
                "<33,2>": "Added ability to copy code ready to paste for new SRP Forums",
                "<33,3>": "Updated service-oriented metadata to support routines that can access other service modules",
                "<33,4>": "Updated F1 to search new SRP Wiki website",
                "<33,5>": "Improved performance during startup",
                "<33,6>": "Removed special case code for a deprecated application",
                "<33,7>": "Fixed XML mode failing to perform syntax highlighting",
                "<33,8>": "Fixed bug not allowing SRP Editor to run in OI 10",
                "<33,9>": "Fixed bug where keywords other than Compile at beginning of first line would force SAVE_AS intead of SAVE",
                "<33,10>": "Fixed bug where wrong statistics would appear in the status bar when start SRP Editor with opened documents"
            },
            "<34>": {
                "<34,1>": "2.6.2",
                "<34,2>": "Added Justify Array tool for making arrays look nice and neat (Ctrl+J)",
                "<34,3>": "Added \"Open as Read Only\" to Open Record dialog, allowing users to open records without locking them",
                "<34,4>": "Added \"Find\" menu item in the context menu to make finding the current selection or word quick and convenient",
                "<34,5>": "Added option to assign F1 to SRP Help and Shift+F1 to OI Help",
                "<34,6>": "Updated Save logic to display Save As dialog if the stored procedure's name has changed",
                "<34,7>": "Fixed bug where inaccurate compilation errors were being reported",
                "<34,8>": "Fixed bug where saving a new entity for the first time failed to pre-populate the entity name",
                "<34,9>": "Fixed bug where leading white space was bring trimmed from block comments during the Format command",
                "<34,10>": "Fixed bug where Print dialog's Paper Size field was not always correct",
                "<34,11>": "Fixed bug where using the up arrow to scroll up would cause the cursor to skip a line",
                "<34,12>": "Fixed bug where Shift Left and Shift Right buttons weren't working correctly",
                "<34,13>": "Fixed bug where Ctrl+D would duplicate lines on read only files instead of doing nothing like it should",
                "<34,14>": "Fixed bug where the entitiy Save As dialog would always reset the \"This Application Only\" setting for the entity Open dialog"
            },
            "<35>": {
                "<35,1>": "2.6.1",
                "<35,2>": "Added F12 as Accelerator for the Goto Source functionality (for Visual Studio habits)",
                "<35,3>": "Updated SRP Editor to use new SRPUtil.ocx: a copy of SRPControls.ocx with different ProgIDs so that it doesn't conflict with commercial SRP ActiveX Controls",
                "<35,4>": "Updated SRP Editor to synchronize tab order with order of documents in Favorites pane",
                "<35,5>": "Updated SRP Editor to re-open previously opened documents in their original tab order when started",
                "<35,6>": "Updated user interface to be more responsive, especially on shutdown",
                "<35,7>": "Updated RDK and About dialogs to be closed with the ESC key",
                "<35,8>": "Updated Record Open dialog to allow user to stop a refresh at any time",
                "<35,9>": "Updated Record Open dialog to select default Table/Record in listboxes when it opens",
                "<35,10>": "Fixed bug where error status would be shown when successfully running a stored procedure (Ctrl+F9) rather than an OK status",
                "<35,11>": "Fixed bug where pressing Ctrl+T on the first line would cause a crash",
                "<35,12>": "Fixed bug where clicking on Favorites that was already active would not return focus back to editor",
                "<35,13>": "Fixed bug where Autocomplete would not display functions from some inherited applications",
                "<35,14>": "Fixed bug where Call Tips would not display information for functions from some inherited applications",
                "<35,15>": "Fixed bug where Goto Source functionality would not work in certain circumstances",
                "<35,16>": "Fixed bug where a new record, when saved, would not appear correctly in the Most Recently Used list, making it impossible to open it from there",
                "<35,17>": "Fixed bug where clicking a drop down item of the Command Line was moving focus out of the Command Line",
                "<35,18>": "Fixed bug where Replace All would not replace all instances if replacement was larger than original string",
                "<35,19>": "Fixed bug where document would not appear as needing to be saved after Replace All",
                "<35,20>": "Fixed bug where users would get a license warning in the Options dialog if they didn't have a license for the SRP Editor control but had a license for the SRP Editor itself"
            },
            "<36>": {
                "<36,1>": "2.6",
                "<36,2>": "Added support for displaying autocomplete dropdowns for service-oriented stored procedures using user-defined metadata",
                "<36,3>": "Added Favorites panel (Toggle with F8)",
                "<36,4>": "Added ability to hide tabs permanently",
                "<36,5>": "Added ability to change status pane size using splitter",
                "<36,6>": "Added ability to close windows using Ctrl+W",
                "<36,7>": "Updated Shift+F1 feature to go to SRP's Wiki instead of CHM help files (which will no longer ship with SRP Products)",
                "<36,8>": "Fixed bug where return value would not appear in status window when running a routine using Ctrl+F9",
                "<36,9>": "Fixed crash that would sometimes occur when pasting text into a function (Requires SRPEditor.ocx 3.0.3 or SRPControls.ocx 3.0.7)",
                "<36,10>": "Fixed bug where spaces woudl be converted into tabs when in record mode (Requires SRPEditor.ocx 3.0.3 or SRPControls.ocx 3.0.7)",
                "<36,11>": "Fixed cursor positioning bug (Requires SRPEditor.ocx 3.0.3 or SRPControls.ocx 3.0.7)",
                "<36,12>": "Fixed bug where selected text would sometimes appear unselected in records (Requires SRPEditor.ocx 3.0.3 or SRPControls.ocx 3.0.7)",
                "<36,13>": "Fixed bug where remainder of current line would be selected when an editor was first activated (Requires SRPEditor.ocx 3.0.3 or SRPControls.ocx 3.0.7)",
                "<36,14>": "Fixed bug where LengthChanged event was always firing rather than only firing when the lenfth of the document actually changes (Requires SRPEditor.ocx 3.0.3 or SRPControls.ocx 3.0.7)",
                "<36,15>": "Fixed bug where calltip would appear after typing an open parenthesis inside a string (Requires SRPEditor.ocx 3.0.3 or SRPControls.ocx 3.0.7)"
            },
            "<37>": {
                "<37,1>": "2.5.6",
                "<37,2>": "Fixed bug where not having SRP ReportTable or SRP Subclass controls licensed caused license warnings despite having SRP Editor licensed"
            },
            "<38>": {
                "<38,1>": "2.5.5",
                "<38,2>": "Fixed bug where recently opened documents would not reopen upon startup"
            },
            "<39>": {
                "<39,1>": "2.5.4",
                "<39,2>": "Updated Status window to only use black text but to incorporate icons",
                "<39,3>": "Fixed bug where SRP Editor would beep evertime documents opened during startup"
            },
            "<40>": {
                "<40,1>": "2.5.3",
                "<40,2>": "Added \"OPENDOCUMENTINFO\" service to SRP_Editor_Utility"
            },
            "<41>": {
                "<41,1>": "2.5.2",
                "<41,2>": "Fixed error in which the \"Compile and Execute\" command was compiling but not executing"
            },
            "<42>": {
                "<42,1>": "2.5.1",
                "<42,2>": "Added ability to disable sound effects (except for compiling code with errors)"
            },
            "<43>": {
                "<43,1>": "2.5",
                "<43,2>": "Added SRP_ActiveX_Info.exe support",
                "<43,3>": "Added SRP_Controls.ocx help support",
                "<43,4>": "Fixed bug where new stored procedures could not be saved if inherited stored procedure already exists"
            },
            "<44>": {
                "<44,1>": "2.4.1",
                "<44,2>": "Removed debug statement"
            },
            "<45>": {
                "<45,1>": "2.4",
                "<45,2>": "Fixed error in which entities accessed via Repository had their line breaks restored back to @FMs, which the SRP Editor expects when parsing and displaying"
            },
            "<46>": {
                "<46,1>": "2.3.9",
                "<46,2>": "Updated logic to use Repository to open entities whenever possible instead of reading records directly; allows for better interaction with other tools such as SRP Mobile Repository"
            },
            "<47>": {
                "<47,1>": "2.3.8",
                "<47,2>": "Added SRP_Taskbar and SRP_TcpClient to the help file references"
            },
            "<48>": {
                "<48,1>": "2.3.7",
                "<48,2>": "Fixed bug where SRP Editor would crash during VNAV preprocessing in OI 9.1.1"
            },
            "<49>": {
                "<49,1>": "2.3.6",
                "<49,2>": "Added TCL tab to the options dialog to allow users to supply routines whose parameter counts are not stored in object code",
                "<49,3>": "Updated command line to support built-in OI routines when too few parameters are passed"
            },
            "<50>": {
                "<50,1>": "2.3.5",
                "<50,2>": "Fixed bug where commented out lines containing semicolons where not getting removed, so keywords such as THEN were erroneously altering the indentation"
            },
            "<51>": {
                "<51,1>": "2.3.4",
                "<51,2>": "Fixed bug where some commented out lines were causing errors in formatting when using the Format command"
            },
            "<52>": {
                "<52,1>": "2.3.3",
                "<52,2>": "Fixed bug where cancelling the Windows.Close_All command would result in a VNAV"
            },
            "<53>": {
                "<53,1>": "2.3.2",
                "<53,2>": "Fixed bug where keywords such as End, when appearing after GoTo, would not be colorized correctly and could cause smart indenting to operate incorrectly"
            },
            "<54>": {
                "<54,1>": "2.3.1",
                "<54,2>": "Fixed bug where delims.dat and version.dat files (remnants of testing) were written to the C:\\ drive on startup"
            },
            "<55>": {
                "<55,1>": "2.3",
                "<55,2>": "Added new SRP Utilities help file references, so pressing Shift+F1 while the cursor is on an SRP Utility file will take the user straight to the SRP Utilities help file topic."
            },
            "<56>": {
                "<56,1>": "2.2.9",
                "<56,2>": "Added ability to close Print dialog by pressing ESC"
            },
            "<57>": {
                "<57,1>": "2.2.8",
                "<57,2>": "Fixed bug where the Window.Close_All menu was not closing the child windows"
            },
            "<58>": {
                "<58,1>": "2.2.7",
                "<58,2>": "Fixed bug where Compile & Execute command would not enable"
            },
            "<59>": {
                "<59,1>": "2.2.6",
                "<59,2>": "Fixed bug where print dialog would draw line numbers next to comment blocks in the comment block color",
                "<59,3>": "Fixed bug where modified status of document doesn't reset when using Ctrl+F9",
                "<59,4>": "Replaced command line combo box with subclassed edit line for better performance and reliability in Vista",
                "<59,5>": "Updated Label combo box to show correct column labels for dictionaries",
                "<59,6>": "Fixed bug where compilation wouldn't work on some delevoper class engines"
            },
            "<60>": {
                "<60,1>": "2.2.5",
                "<60,2>": "Fixed bug where Options dialog would break to debugger for first time SRP Editor user"
            },
            "<61>": {
                "<61,1>": "2.2.4",
                "<61,2>": "Added two new panes to status bar to display current application and username",
                "<61,3>": "Added ability to display a custom formatted pane defined in SYSENV*SRP_EDITOR_CUSTOM_STATUS_PANE, allowing users to display something useful about the SRP Editor's environment"
            },
            "<62>": {
                "<62,1>": "2.2.3",
                "<62,2>": "Fixed bug where attempting to save to a non-existant table would not notify user that save failed",
                "<62,3>": "Added logic to work around OI bug where large files somehow corrupt the results of Get_Property",
                "<62,4>": "Updated Convert and Save As... function to default stored procedures saved as DOS files to <STORE_PROCUDURE_NAME>.TXT"
            },
            "<63>": {
                "<63,1>": "2.2.2",
                "<63,2>": "Added logic to use QuickDexes when available when populating open/save record dialog"
            },
            "<64>": {
                "<64,1>": "2.2.1",
                "<64,2>": "Improved Open Entity dialog performance by removing orphaned entities check and yield statements",
                "<64,3>": "Improved Open Record dialog performance by caching key lists and optimizing dynamic arrays"
            },
            "<65>": {
                "<65,1>": "2.2",
                "<65,2>": "Updated Open Entity dialog to include records from CODE tables and to display them in a more informative way",
                "<65,3>": "Updated Dos type documents such that only the file name appears in the tab to keep it shorter",
                "<65,4>": "Added logic to update entity caches whenever and entity is created or deleted to avoid having to refresh entities",
                "<65,5>": "Added advanced support for U2 tables, included customizations to optimize table selects on U2 tables"
            },
            "<66>": {
                "<66,1>": "2.1.9",
                "<66,2>": "Fixed bug where Copy to HTML Code function would allow comment color to bleed onto following line"
            },
            "<67>": {
                "<67,1>": "2.1.8",
                "<67,2>": "Fixed bug where Format function would unindent LOOP blocks with While/Until on the same line as Loop"
            },
            "<68>": {
                "<68,1>": "2.1.7",
                "<68,2>": "Added EXPLORE command for opening Windows Explorer to REVBOOT or other specified directory",
                "<68,3>": "Updated Format function to unindent dividing comments (such as '*--------') just below GoSub labels",
                "<68,4>": "Fixed bug where Format function would unindent For loops with While/Until on the same line",
                "<68,5>": "Fixed bug where Copy as HTML Code function would fail to preserve correct font throughout entire content"
            },
            "<69>": {
                "<69,1>": "2.1.6",
                "<69,2>": "Fixed bug in which old Styles registry overrode new Styles2 registry; it is now be the other way around."
            },
            "<70>": {
                "<70,1>": "2.1.5",
                "<70,2>": "Updated option dialog to maintain both Styles and Styles2 registry entries, for backward compatability",
                "<70,3>": "Added new TCL command, HISTORY, to display SRP Editor version history on demand"
            },
            "<71>": {
                "<71,1>": "2.1.4",
                "<71,2>": "Updated styles, when stored to registry, to use character delimiters instead of system delimiters to avoid problems other localizations"
            },
            "<72>": {
                "<72,1>": "2.1.3",
                "<72,2>": "Fixed bug where Format function failed to recognize comment blocks on a single line, therefore treating the rest of the document as a comment",
                "<72,3>": "Updated UNIVERSE Compiler to recognize '~' delimiters in personal editions of UNIVERSE"
            },
            "<73>": {
                "<73,1>": "2.1.2",
                "<73,2>": "Ignoring VNAVs in function calls is now optional",
                "<73,3>": "Ignoring VNAVs referenced in Inserts is now optional",
                "<73,4>": "Updated Option Dialog's other pages to better utilize new size"
            },
            "<74>": {
                "<74,1>": "2.1.1",
                "<74,2>": "Updated VNAV checking to eliminate possible VNAVs found in function calls and inserts",
                "<74,3>": "Updated VNAV checking to ensure markers do not point to VNAVs which may also exist as literals in strings or comments",
                "<74,4>": "Added ability to disable VNAV checking in options"
            },
            "<75>": {
                "<75,1>": "2.1",
                "<75,2>": "Added support for VNAV checking",
                "<75,3>": "Updated editor to jump to already opened records or DOS files instead of opening copies",
                "<75,4>": "Fixed bug in Viewer related to issues using Drive() with root drive letters"
            },
            "<76>": {
                "<76,1>": "2.0.10",
                "<76,2>": "Increased U2 Bond buffer size to 1MB, to support larger records"
            },
            "<77>": {
                "<77,1>": "2.0.9",
                "<77,2>": "Updated OCX version checking to be more accurate than standard string comparison",
                "<77,3>": "Fixed bug where selecting large numbers would break to the debugger",
                "<77,4>": "Fixed bug where taskbar icon would appear when using call tips",
                "<77,5>": "Fixed bug where multiple lines of comments ending with '|' caused hang up when inserting new lines"
            },
            "<78>": {
                "<78,1>": "2.0.8",
                "<78,2>": "Fixed bug where selecting large numbers broke to debugger"
            },
            "<79>": {
                "<79,1>": "2.0.7",
                "<79,2>": "Added support to colorize identifiers ending with '@' and '%'"
            },
            "<80>": {
                "<80,1>": "2.0.6",
                "<80,2>": "Added support to colorize identifiers ending with '$'"
            },
            "<81>": {
                "<81,1>": "2.0.5",
                "<81,2>": "Added ability to copy code as HTML",
                "<81,3>": "Added ability to delete tabs as spaces using Shift+Backspace",
                "<81,4>": "Added ability to delete tabs as spaces using Shift+Delete",
                "<81,5>": "Fixed autocomplete bug where wrong drop down would appear for $insert if first letter was anything other than 'a'",
                "<81,6>": "Fixed autocomplete bug where wrong drop down would appear for GoSub and GoTo statements if first letter didn't match a valid label",
                "<81,7>": "Fixed bug where Edge Indicator field in Option dialog fail to initialize"
            },
            "<82>": {
                "<82,1>": "2.0.4",
                "<82,2>": "Updated Format function to use Tab as Spaces and Tab Width option settings",
                "<82,3>": "Updated Print button and menu to disable when the Viewer tab is at the front, preventing users from printing the viewer until such functionality can be added",
                "<82,4>": "Updated Option dialog to disable keywords in Autocomplete list (requires SRPEditor.ocx 2.1.4 or greater)",
                "<82,5>": "Updated AutoCommenting to always place comments at beginning of lines for single line auto comments",
                "<82,6>": "Updated TCL processor to display linebreaks correctly in Viewer and Status windows",
                "<82,7>": "Fixed bug where some Quick Commands caused the Viewer to appear, which caused the replaceable parameters to fail",
                "<82,8>": "Fixed bug where Format function would fail if '/*' appeared within a single-line comment",
                "<82,9>": "Fixed bug where Format button would not enable when viewing U2 code from a record or viewing new, unsaved Stored Procedures",
                "<82,10>": "Fixed bug where Format function would fail if 'loop' appeared after the 'next' statement",
                "<82,11>": "Fixed bug where AutoComment logic would cause the code to creap one space to the left at a time each time a block was commented",
                "<82,12>": "Fixed bug where SRP Editor preventing compilation in Development Runtime Engines"
            },
            "<83>": {
                "<83,1>": "2.0.3",
                "<83,2>": "Fixed bug where Ctrl+L faile to Goto Label when editing a Record in Code mode",
                "<83,3>": "Fixed bug where Goto Label dialog would list record fields instead of code labels when editing a Record in Code mode",
                "<83,4>": "Added support for up to 5 customized toolbar buttons, called Quick Commands"
            },
            "<84>": {
                "<84,1>": "2.0.2",
                "<84,2>": "Updated Help system to better navigate to appropriate help files",
                "<84,3>": "Update F1 help to maximize OI help file"
            },
            "<85>": {
                "<85,1>": "2.0.1",
                "<85,2>": "Added TCL option which causes the HTML viewer to always appear on top when executing commands",
                "<85,3>": "Updated About Box with new SRP graphic",
                "<85,4>": "Updated RDK command to produce 8.0 compatable RDKS when using the V option",
                "<85,5>": "Fixed bug where autocomplete would flicker for non-matched prefixes",
                "<85,6>": "Fixed bug where autocomplete for GoTo/GoSub labels would be out of order, causing incorrect completions",
                "<85,7>": "Fixed bug where some unicode characters were still causing syntax colors to offset"
            },
            "<86>": {
                "<86,1>": "2.0",
                "<86,2>": "Added autocompletion when writing code",
                "<86,3>": "Added ability to specify table types",
                "<86,4>": "Added ability to view HTML and XML documents with syntax highlighting",
                "<86,5>": "Added ability to enable tabs to made up of spaces only",
                "<86,6>": "Added Show Line Numbers option",
                "<86,7>": "Added option to disable autocompletion",
                "<86,8>": "Fixed bug where unicode characters would offset code highlighting",
                "<86,9>": "Added full-color printing support",
                "<86,10>": "Update OLE Control version check to show tooltip warning instead of locking users out",
                "<86,11>": "Added Ctrl+Shift+F accelerator for running SRP Table Search Utility"
            },
            "<87>": {
                "<87,1>": "1.1",
                "<87,2>": "Added support for SRP OLE Controls version 2.0"
            },
            "<88>": {
                "<88,1>": "1.0.3",
                "<88,2>": "Added Version History record",
                "<88,3>": "Updated runtime check logic",
                "<88,4>": "Updated About Box",
                "<88,5>": "Fixed bug where selecting numbers larger than 16 digits would break to the debugger"
            },
            "<89>": {
                "<89,1>": "1.0.2",
                "<89,2>": "Added support for %DATE% and %TIME% fields in AutoText functionality"
            },
            "<90>": {
                "<90,1>": "1.0.1",
                "<90,2>": "Updated support for new SRP Licensing model"
            },
            "<91>": {
                "<91,1>": "1.0",
                "<91,2>": "Initial Release"
            }
        }
    }
}